//Personal Calendar Class
//Developed By:

//Elizabeth Carter, Portsmouth High School, Portsmouth Rhode Island
//(401)-683-2124 Office Hours M-F:  2-3 pm.  Email:  ride2535@ride.ri.net

//Larry Chiappetta, Moses Brown School, Providence, Rhode Island
//(401) 831-7350 ext. 180 Office Hours M-F:  2-3pm  Email:  lchiappetta@mosesbrown.org

//Mario Correia, Barrington High School, Barrington, Rhode Island
//(401) 247-3150 ext. 118 Office Hours M-F:  2-3pm  Email:  correiama@bpsmail.org

//In completion of the Java Workshop for High School Teachers August 2003 and June 2004
//at Stonehill College, Easton MA, via funding from the National Science Foundation
//Latest version 6/29/2004

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;


public class PersonalCalendar extends JFrame implements ActionListener
{
	private JLabel TheDate;					//Today's date in format: Thursday June 24 2004
	private JLabel Pic ;					//Photo for this Month
	private JPanel buttonPanel;				//Panel displays numerals for days of month
	private JPanel buttonPanelDays;			//Panel displays weekdays Sunday through Saturday
	private JPanel picDatePanel;			//Panel displays Picture and Date (top of window)
	private JPanel monYrPanel;				//Combo boxes: Months & Years
	private JPanel lowerPanel;				//Panel displays combo boxes and buttons
	private JButton buttons[];				//Buttons represent possible calendar numeral locations
	private JButton buttonsDays[];			//Buttons represent weekdays Sunday through Saturday
	private JComboBox cboMonths, cboYears;	//Combo boxes Months, Years
	private Icon photos[ ] = new Icon [13];	//Photos for monthly Themes

	//Used for opening up to today's date
	public static Calendar today = GregorianCalendar.getInstance();
	private int thisYear = today.get(Calendar.YEAR);
	private int thisDayofM = today.get(Calendar.DAY_OF_MONTH);
	private int thisMonth = today.get(Calendar.MONTH);
	private int thisDayofWeek = today.get(Calendar.DAY_OF_WEEK);
	private int firstDayofM = today.get(Calendar.DAY_OF_WEEK_IN_MONTH);

	//Used for the user's day SELECTED on calendar
	private int baseYear = 1990;			//Starting year for calendar and array
	private int selectedYear = thisYear-baseYear; //Used to intitialize array index
	private int selectedDayofM =thisDayofM;
	private int selectedMonth =0;
	private int selectedDayofWeek =thisDayofWeek;
	private int selectedFirstDayofM = firstDayofM;
	private JMenuItem AnimeMenuItem, FlowersMenuItem, SceneryMenuItem;  //Picture themes
	private JMenuBar menuBar;				//Theme menu

	private boolean menuSelected = false;
	private int offset;  //Used to determine which day is the first of the month 0-Sunday 6-Saurday
	final private String strDay [ ] =
	{ "  ", "Sunday", "Monday", "Tuesday","Wednesday","Thursday","Friday",
			"Saturday"	};
	final private String strYear [ ] =
	{
		"1990", "1991", "1992","1993","1994",
		"1995", "1996", "1997","1998","1999","2000",
		"2001","2002","2003","2004","2005", "2006",
		"2007", "2008", "2009", "2010", "2011", "2012"
	};
	final private String strMonth [ ] =
	{ "January", "February", "March","April","May","June",
		"July","August","September","October","November",
		"December"
	};
	final private int numOfDaysInMonth [] =
	{ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
	final private String strImage[] =
	{ "jan","feb","mar","apr","may","jun","jul","aug","sept","oct","nov","dec"};

  	public PersonalCalendar()
   	{
      	super( "Calendar" );

		System.out.println();
		Container c = getContentPane();

		menuBar = new JMenuBar(); //Create the menubar
		JMenu themeMenu = new JMenu("Theme");  //Create the menus
		menuBar.add(themeMenu);  //Add the menus to the menu bar
		setJMenuBar(menuBar);  //Place menu on the frame
		//Create the menu items
		AnimeMenuItem = new JMenuItem("Anime");
		FlowersMenuItem = new JMenuItem("Flowers");
		SceneryMenuItem = new JMenuItem ("Scenery");
		//Add the menu item to the appropriate menu
		themeMenu.add(AnimeMenuItem);
		themeMenu.add(FlowersMenuItem);
		themeMenu.add(SceneryMenuItem);
		//Create a MenuListener object
		MenuListener m = new MenuListener();
		//Register the listener with the appropriate menu
		AnimeMenuItem.addActionListener(m);
		FlowersMenuItem.addActionListener(m);
		SceneryMenuItem.addActionListener(m);
		//Displays current date top right panel
		TheDate = new JLabel ("Today is:  " +strDay[thisDayofWeek]+", " +strMonth[thisMonth] + " " +
							thisDayofM + ", "+
							+ thisYear + "  ");
		cboMonths = new JComboBox (strMonth);  //Places months of year in combo box
		cboMonths.setMaximumRowCount (12);  //Displays all of the months in combo box
		cboMonths.setSelectedIndex(thisMonth);  //Have current calendar display current month
		selectedMonth = thisMonth;  //Now need to have change heard
		cboYears = new JComboBox (strYear);
		cboYears.setMaximumRowCount (5);  //Displays Five years in combo box
		int myIndex=thisYear-baseYear;  //Used for array index
		cboYears.setSelectedIndex(myIndex);  //Now need to have change heard
		//Adding actionlisteners
		cboMonths.addActionListener(this);
		cboYears.addActionListener(this);
		//Put days of week in grid
		buttonPanelDays = new JPanel();
		buttonsDays = new JButton[ 7 ];
		buttonPanelDays.setLayout(new GridLayout( 1, 7 ) );  //Displays days of week in one row
		//put days of month in grid
		buttonPanel = new JPanel();
		buttons = new JButton[ 42 ];
		buttonPanel.setLayout(new GridLayout( 7, 6 ) );  //Displays grid for numerals in month
		picDatePanel = new JPanel();  //Panel in top portion of window contains picture and today's date
		monYrPanel = new JPanel();  //Panel in middle of window contains combo boxes for month and year
		picDatePanel.setLayout(new GridLayout( 1, 2, 50, 0 ) );
		monYrPanel.setLayout(new GridLayout( 1, 2 ) );
		//adds picture to the panel
		Pic = new JLabel();   //Creates empty label
		picDatePanel.add(Pic);	  //Add picture to panel
		picDatePanel.add(TheDate);  //Add date to panel
		monYrPanel.add(cboMonths);
		monYrPanel.add(cboYears);
		lowerPanel = new JPanel();
		lowerPanel.setLayout(new BorderLayout());
		//Put weekdays in
		for ( int i = 0; i <buttonsDays.length; i++ )
		{
			buttonsDays[ i ] = new JButton( strDay[i+1] );
			buttonPanel.add( buttonsDays[ i ] );
		}
		//Put numbers in grid
		for ( int i = 0; i < buttons.length; i++ )
		{
			buttons [i] = new JButton("");
			buttonPanel.add(buttons[i]);
		}

		ButtonHandler handler = new ButtonHandler();  //Object to implement ActionListener interface
		for ( int i = 0; i <buttons.length; i++ )
		{
			buttons[i].addActionListener (handler);
		}
		lowerPanel.add(monYrPanel, BorderLayout.NORTH);
		lowerPanel.add( buttonPanel, BorderLayout.CENTER );
		c.add(lowerPanel,BorderLayout.SOUTH );
		c.add(picDatePanel, BorderLayout.CENTER);
		setSize( 800, 500 );
		drawCalendar();
   	}  //End of Calendar constructor

   	private class MenuListener implements ActionListener
	{
		 public void actionPerformed(ActionEvent e)
		 {
			String cms = e.getActionCommand();	//get command string for the event
			if (e.getSource() instanceof JMenuItem)
			{
				if (cms.equals("Anime"))
				{
					for (int i=0;i<12;i++)
					{photos[i] = new ImageIcon (strImage[i]+".JPG");}
				}
				else if (cms.equals("Flowers"))
				{
					for (int i=0;i<12;i++)
					photos[i] = new ImageIcon (strImage[i]+"1.JPG");
				}
				else if (cms.equals("Scenery"))
				{
					for (int i=0;i<12;i++)
					photos[i] = new ImageIcon (strImage[i]+"2.JPG");
				}
				Pic.setIcon(photos[selectedMonth]);
			}
			menuSelected = true;
		  }
	}
   	public int getMonth(int m)
   	{
		return m + Calendar.JANUARY;
   	}
   	public int getYear(int y)
   	{
	   return y + baseYear;
   	}
	public void drawCalendar()
	{
		//Uses GregorianCalendar Class to find out what day the month starts
		GregorianCalendar cal = new GregorianCalendar(getYear(selectedYear),getMonth(selectedMonth),1);
		int day = cal.get(Calendar.DAY_OF_WEEK);
		switch(day)
		{
			case Calendar.SUNDAY:
				System.out.println("Sunday");
				offset = 0;
				break;
			case Calendar.MONDAY:
				System.out.println("Monday");
				offset = 1;
				break;
			case Calendar.TUESDAY:
				System.out.println("Tuesday");
				offset = 2;
				break;
			case Calendar.WEDNESDAY:
				System.out.println("Wednesday");
				offset = 3;
				break;
			case Calendar.THURSDAY:
				System.out.println("Thursday");
				offset = 4;
				break;
			case Calendar.FRIDAY:
				System.out.println("Friday");
				offset = 5;
				break;
			case Calendar.SATURDAY:
				System.out.println("Saturday");
				offset = 6;
				break;
		}
		for(int i = 0; i < offset; i++)
			buttons[i].setText("");
		for(int i = offset; i < buttons.length; i++)
		{
			if(i-offset+1 <= getMaxDay(selectedMonth))
			{
				buttons[i].setText(String.valueOf(i-offset+1));
				if (menuSelected == true)
					Pic.setIcon(photos[selectedMonth]);
				else
					Pic.setIcon(new ImageIcon("cal.jpg"));
			}
			else
				buttons[i].setText("");
		}
	}   //end of drawCalendar

	public int getMaxDay(int month)
	//pre:  month is valid
	//post: returns number of days in month
	{
		if(month == 1 && IsLeapYear(getYear(selectedYear)) )
		{
			return 29;
		}
		else
		{
			return numOfDaysInMonth[month];
		}
	}

	public void actionPerformed( ActionEvent e)
	{
		if(e.getSource() == cboMonths)
		{
			selectedMonth = cboMonths.getSelectedIndex();   //Gets selected month in combobox
			setCalendarLayout(selectedMonth, selectedYear); //Draws calendar for selected month and year
		}
		else if (e.getSource() == cboYears)
		{
			selectedYear = cboYears.getSelectedIndex();     //Gets selected year in combobox
			setCalendarLayout(selectedMonth, selectedYear); //Draws calendar for selected month and year
		}
	}

	// inner class to handle button events
	private class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			ReadFile rf = new ReadFile();						//Text file
			rf.processFiles();
 			int yr = selectedYear + baseYear;					//Present year
			int day = Integer.parseInt(e.getActionCommand());	//Day of month
			int mth = selectedMonth+1;							//Present month
			String [][] hArray = rf.getArray();  //create array of month # and day #
			String add="";

			if (hArray[mth][day] != null)		//Determines if present month and day is in text file
			{
				add = hArray[mth][day];			//Message for special day to append onto day message
				Pic.setIcon(new ImageIcon(add+".jpg"));
				System.out.println(add+".jpg");
			}

			String yourWeekDay = dayOfWeek(yr,selectedMonth, day);  //Return the correct weekday

			//Now handle special dates like Mother's Day, etc.
			//First determine which occurrence of this weekday this is in the given month
			int dayOcc = (int)(day/7) + (day%7==0?0:1);    //Use of conditional operator
			//Determine if day selected is a special day.  If so add comment to day message

			//Martin Luther King Jr. Day
			if (mth==1 && dayOcc==3 && yourWeekDay.equals("Monday"))
			{
				add = "Martin Luther King Day";
				Pic.setIcon(new ImageIcon("mlkday.jpg"));
			}
			//President's Day
			if (mth==2 && dayOcc==3 && yourWeekDay.equals("Monday"))
			{
				add = "President's Day";
				Pic.setIcon(new ImageIcon("presidents.jpg"));
			}
			//Mother's Day
			if (mth==5 && dayOcc==2 && yourWeekDay.equals("Sunday"))
			{
				add = "Mother's Day";
				Pic.setIcon(new ImageIcon("mother.jpg"));
			}
			//Father's Day
			if (mth==6 && dayOcc==3 && yourWeekDay.equals("Sunday"))
			{	add = "Father's Day";
				Pic.setIcon(new ImageIcon("father.jpg"));
			}
			//Labor Day - First Monday in September
			if (mth==9 && dayOcc==1 && yourWeekDay.equals("Monday"))
			{	add = "Labor Day";
				Pic.setIcon(new ImageIcon("labor.jpg"));
			}
			//Columbus Day
			if (mth==10 && dayOcc==2 && yourWeekDay.equals("Monday"))
			{	add = "Columbus Day";
				Pic.setIcon(new ImageIcon("columbus.jpg"));
			}
			//Thanksgiving -- 4th Thursday in November
			if (mth==11 && dayOcc==4 && yourWeekDay.equals("Thursday"))
			{	add = "Thanksgiving";
				Pic.setIcon(new ImageIcon("thanksgiving.jpg"));
			}
			//Memorial Day -- Last Monday in May
			//if day >=25 and a monday then it is observered Memorial Day
			if (mth==5 && dayOcc>=4 && day>=25 && yourWeekDay.equals("Monday"))
			{
				add = "Memorial Day Observed";
				Pic.setIcon(new ImageIcon("flag.jpg"));
			}
			if (mth==3 || mth == 4 &&  yourWeekDay.equals("Sunday"))
			{
				//check for Easter Sunday
				if (isEaster(mth, day, yr))
				{
					add = "Happy Easter, Bunny!";  	//Easter Sunday
					Pic.setIcon(new ImageIcon("easter.jpg"));
				}
			}


			JOptionPane.showMessageDialog
			(null,"You picked:  "  + yourWeekDay  + ",  "+ strMonth[selectedMonth] + " " + e.getActionCommand() + ", "+ getYear(selectedYear)+"  \n"+add, "Date",
				JOptionPane.PLAIN_MESSAGE
			);
			Pic.setIcon(photos[selectedMonth]);
		}

		// get the date of easter for this year and set the calender
		boolean isEaster(int mth, int dayofmonth, int year)
		{

			int c,n,k,i,j,l,m,d;
				c = year / 100;
				n = year - 19 * ( year / 19 );
				k = ( c - 17 ) / 25;
				i = c - c / 4 - ( c - k ) / 3 + 19 * n + 15;
				i = i - 30 * ( i / 30 );
				i = i - ( i / 28 ) * ( 1 - ( i / 28 ) * ( 29 / ( i + 1 ) )
					* ( ( 21 - n ) / 11 ) );
				j = year + year / 4 + i + 2 - c + c / 4;
				j = j - 7 * ( j / 7 );
				l = i - j;
				m = 3 + ( l + 40 ) / 44;
				d = l + 28 - 31 * ( m / 4 );
				return (mth==m && dayofmonth==d );
		}

	}

   	void setCalendarLayout( int month, int year)
   	{
		drawCalendar();  //given a valid month and year set the calendar to it
	}

   	public static void main( String args[] )
   	{
	  	PersonalCalendar app = new PersonalCalendar();
	  	app.setVisible(true);
	  	app.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   	}

 boolean IsLeapYear(int year)
    { 	//Purpose:  Determines if given year is a leap year.
    	// given:   year = given year after 1582 (start of the Gregorian calendar).
    	// returns:  TRUE if given year is leap year, FALSE if not.
		if (year % 400 == 0) return true;
		if (year % 100 == 0) return false;
		if (year % 4 == 0) return true;
		return false;
    }

	public String dayOfWeek (int year, int month, int day)
	{
		System.out.print("You sent: year" + year + " month:  " +month + "   day  " + day);
		int dayOfWeek;
		GregorianCalendar cal = new GregorianCalendar (year, month, day);
		dayOfWeek = cal.get (GregorianCalendar.DAY_OF_WEEK);

		switch(dayOfWeek)
		{
			case 1:	return "Sunday";
			case 2:	return "Monday";
			case 3:	return "Tuesday";
			case 4:	return "Wednesday";
			case 5:	return "Thursday";
			case 6:	return "Friday";
			case 7:	return "Saturday";
			default:return "Data Error!!!";
		}
	}

	// Use class to read special holidays from a textfile
	class ReadFile
	{
		StreamTokenizer stk;
		String [][] holidayArray;

		public ReadFile()
		{
			try {
				stk = new StreamTokenizer(new FileReader(new File("holiday.txt")));
				}
			catch(Exception e)
			{
				System.out.println("An error has occured while opening initial files");
				System.out.println("Exiting...");
				System.exit(1);
			}
		}

		public void processFiles()
		{
			try {
				stk.nextToken();
				}
			catch(Exception e)
				{
				System.out.println(e.getMessage());
				}
			int size = (int)stk.nval;  //how many items list; first item in holiday.txt

			holidayArray = new String[13][32];
			stk.wordChars(40,150);  //allow for _ ' .  as part of word

			for(int i = 0 ; i < size; i++)
			{
				try
				{
					stk.nextToken();
					int month = (int)stk.nval;  	//1st item in each line of text is month #
					stk.nextToken();
					int day = (int)stk.nval;		//2nd item in each line of text is day #
					stk.nextToken();
					String celebration = stk.sval;	//3rd item in each line of text is special day message

					celebration = CleanUnderscores(celebration);  //method to clear underscores from special message

					holidayArray[month][day] = new String(celebration);
				}
				catch(Exception e)
				{
					System.out.println(e.getMessage());
				}
			}
		}

		public String CleanUnderscores(String celebration)
		//Method clears underscores from string
		{
			String s = new String();
			s = celebration.replace('_',' ');
			System.out.println("celebration " + s);
			return s;
		}

	 	public String [][] getArray()
	 	{
		 	return holidayArray;
	 	}
	}
} // close of class PersonalCalendar
