//Please note the following: This is an integer calculation. All variables are integers and all remainders from division are dropped.

//The algorithm uses the year, y, to give the month, m, and day, d, of Easter. The symbol * means multiply.
//taken from:  http://aa.usno.navy.mil/faq/docs/easter.html
private Date  calculate_the_date_of_Easter(int year)
{
private int c,n,k,i,j,l,m,d;
    c = y / 100;
    n = y - 19 * ( y / 19 );
    k = ( c - 17 ) / 25;
    i = c - c / 4 - ( c - k ) / 3 + 19 * n + 15;
    i = i - 30 * ( i / 30 );
    i = i - ( i / 28 ) * ( 1 - ( i / 28 ) * ( 29 / ( i + 1 ) ) * ( ( 21 - n ) / 11 ) );
    j = y + y / 4 + i + 2 - c + c / 4;
    j = j - 7 * ( j / 7 );
    l = i - j;
    m = 3 + ( l + 40 ) / 44;
    d = l + 28 - 31 * ( m / 4 );
    Date date1 = new Date(m,d,y);
    System.out.println("happy Easter: on : "  + date1);
    return date1;
}

//For example, using the year 2010,
//y=2010,
//c=2010/100=20,
//n=2010 - 19 x (2010/19) = 15,
//etc. resulting in Easter on April 4, 2010.

//The algorithm is due to J.-M. Oudin (1940) and is reprinted in the Explanatory Supplement to the Astronomical Almanac, ed. P. K. Seidelmann (1992). See Chapter 12, "Calendars", by L. E. Doggett.

